package patch

import (
	"encoding/json"
	"time"
)

type Status string

const (
	StatusFailed    Status = "failed"
	StatusPending   Status = "pending"
	StatusPaused    Status = "paused"
	StatusInRollout Status = "in rollout"
)

// Statuses is a list of all possible statuses sorted by priority.
// This is used to determine the status of a patch in a deterministic order.
// A patch with a higher priority status will be applied first.
var Statuses = []Status{
	StatusFailed, // highest priority
	StatusInRollout,
	StatusPending,
	StatusPaused, // lowest priority
}

// Metadata of a ring patch.
//
// A patch is a set of operations that can be applied to the cells in a ring.
// The metadata of a patch is used to determine which cells should be patched
// and in which order.
type Metadata struct {
	// ID is the unique identifier of the patch.
	// It is used to reference the patch in the patch file name
	ID string `json:"id"`
	// Priority is the priority of the patch.
	// Patches with lower priority are applied first.
	Priority int `json:"priority"`
	// Ring is the ring to which the patch should be applied next.
	Ring int `json:"ring"`
	// PauseAfterRing is the ring at which the patch should be paused.
	// It can be used to limit auto-deploy packages rollout to ring 0 only.
	// If the patch is not paused at a ring, it will be applied to the next rings until it reaches the last ring.
	PauseAfterRing *int `json:"pause_after_ring,omitempty"`
	// DeleteAfterRing is the ring at which the patch should be removed from the queue as fully applied.
	DeleteAfterRing *int `json:"completed_after_ring,omitempty"`
	// RelatedTo is a list of URLs to merge requests or issues related to the patch.
	// It is used in generated commit messages to track actions related to the patch.
	RelatedTo []string `json:"related_to"`
	// OnlyGitlabUpgrade will generate a fast deployment pipeline with only the GitLab upgrade
	// this field should only be true when the only change in the tenant model is the GitLab version
	OnlyGitlabUpgrade bool `json:"only_gitlab_upgrade"`
	// InRollout indicates whether the patch is in rollout.
	// If the patch is in rollout, it will be applied to the next rings until it reaches the last ring or the patch is paused.
	InRollout bool `json:"in_rollout"`
	// Origin represents the origin of a patch.
	// It's a filed that may help filtering patches generated by a specific tool, i.e. auto_deploy, renovatebot
	Origin string `json:"origin,omitempty"`

	// Error is the error message in case the patch failed to apply and/or rollout.
	// If empty, no error occurred.
	Error string `json:"error,omitempty"`
	// LastStatusUpdate is the last time the status of the patch was updated.
	LastStatusUpdate *time.Time `json:"last_status_update,omitempty"`

	// Patch is the JSON patch to apply to the tenant models.
	Patch json.RawMessage `json:"patch,omitempty"`

	//Rollback indicates to CI that this is a rollback and to execute the appropriate CI pipeline
	Rollback bool `json:"rollback"`
}

func (m *Metadata) Paused() bool {
	return m.PauseAfterRing != nil && m.Ring > *m.PauseAfterRing
}

// Link returns the first element of RelatedTo.
// If RelatedTo is empty, it return an empty string.
func (m *Metadata) Link() string {
	if len(m.RelatedTo) == 0 {
		return ""
	}

	return m.RelatedTo[0]
}

func (m *Metadata) Status() Status {
	if m.Error != "" {
		return StatusFailed
	}

	if m.InRollout {
		return StatusInRollout
	}

	if m.Paused() {
		return StatusPaused
	}

	return StatusPending
}

// Updated updates the LastStatusUpdate field of the metadata.
// It must be called every time the metadata is updated.
func (m *Metadata) Updated() {
	if m.LastStatusUpdate == nil {
		m.LastStatusUpdate = new(time.Time)
	}

	*m.LastStatusUpdate = time.Now().UTC()
}

func MetadataFromJSON(sorce string) (*Metadata, error) {
	meta := new(Metadata)

	if err := json.Unmarshal([]byte(sorce), meta); err != nil {
		return nil, err //nolint:wrapcheck
	}

	return meta, nil
}

func (m *Metadata) Description() string {
	if m.Patch == nil {
		return "Empty patch"
	}

	var patch Patch
	if err := json.Unmarshal(m.Patch, &patch); err != nil {
		return "Invalid patch"
	}

	return patch.String()
}
